
bombs = gideros.class(Sprite)

function bombs:init(xPos, yPos)
	-- [[ Create Bombs shapes ]] --
	self.bombShape = b2.PolygonShape.new()
	self.bombShapePoints = {	9.07007789611816, 2.3787670135498,  		-- Vertex 1
							4.037841796875, 11.6023125052452,				-- Vertex 2
							-4.98668527603149, 11.5833916068077,			-- Vertex 3
							-9.57953750342131, 1.97161865234375,			-- Vertex 4
							0, -12.5										-- Vertex 5
							}
	self.bombShape:set(unpack(self.bombShapePoints))
	self.fd = {shape = self.bombShape, density = 2, restitution = 0.0, friction = 0.0}
	self.body = world:createBody(
				{
					type = b2.DYNAMIC_BODY, 
					position = {x = xPos, y = yPos},
				}
	)
	self.body.name = "bomb"
	self.body:createFixture(self.fd)
	self.bombSprite = Bitmap.new(ingameGFX:getTextureRegion("bomb.png"))
	self.bombSprite:setAnchorPoint(0.5, 0.5)

	self.bombSprite.body = self.body
	self.bombSprite.body.sprite = self.bombSprite
	self:addChild(self.bombSprite)
end

--local removeTimer = Timer.new(1000,1)

explosion = gideros.class(Sprite)

function explosion:init()
	self.explosionFrames = {
		Bitmap.new(ingameGFX:getTextureRegion("boom1.png")),
		Bitmap.new(ingameGFX:getTextureRegion("boom2.png")),
		Bitmap.new(ingameGFX:getTextureRegion("boom3.png")),
		Bitmap.new(ingameGFX:getTextureRegion("boom4.png")),
		Bitmap.new(ingameGFX:getTextureRegion("boom5.png")),
		Bitmap.new(ingameGFX:getTextureRegion("boom6.png")),
		Bitmap.new(ingameGFX:getTextureRegion("boom7.png")),
		Bitmap.new(ingameGFX:getTextureRegion("boom8.png")),
	}
	self.explosionAnim = MovieClip.new{
		{1, 3, self.explosionFrames[1]},			
		{4, 7, self.explosionFrames[2]},			
		{8, 11, self.explosionFrames[3]},			
		{12, 15, self.explosionFrames[4]},			
		{16, 19, self.explosionFrames[5]},			
		{20, 23, self.explosionFrames[6]},			
		{24, 27, self.explosionFrames[7]}, 			
		{28, 31, self.explosionFrames[8]}			
	}
	self.explosionAnim:setStopAction(28)
   --[[	removeTimer:addEventListener(Event.TIMER, function()
		stage:removeChild(self.explosionAnim)
	end)
	removeTimer:start()--]]
end


function explosion:play(x, y)
	self.explosionAnim:setPosition(x-self.explosionFrames[3]:getWidth()/2, y-self.explosionFrames[3]:getWidth()/2)
	self.explosionAnim:gotoAndPlay(1)
	sndSfxChannel   = sfx_eliExplosion:play()
	sndSfxChannel:setVolume(0.8)
	stage:addChild(self.explosionAnim)	
--	removeTimer:start()
end