--[[

	---------------------------------------------
	GidHelix
	a simple game made to test and learn 
	Gideros SDK Power and Lua coding.
	
	Coded By Gianluca D'Angelo Copyright (C) 2012
	contact: gregbug@gmail.com
	THIS PROGRAM IS FREEWARE
	
	L'Aquila, 15 Gennaio 2012
	---------------------------------------------
	MODULE: Buggy "Truck" class
	---------------------------------------------
	OK
--]]


-----------------------
-- Buggy/track Class --
-----------------------
buggy = gideros.class(Sprite)

------------------
-- Create Buggy --
------------------
function buggy:init()
	self.rotazione 			= 0
	self.ruotaAnteriore 	= Bitmap.new(ingameGFX:getTextureRegion("ruota.png"))
	self.ruotaPosteriore1 	= Bitmap.new(ingameGFX:getTextureRegion("ruota.png"))
	self.ruotaPosteriore2 	= Bitmap.new(ingameGFX:getTextureRegion("ruota.png"))
	
	local polyGroup 		= {
		{   29.6147537231445, -18.196720123291  ,  15.7786865234375, -13.0163917541504  ,  19.9426193237305, -27.3278694152832  },
		{   -47.4344263076782, -13.0163917541504  ,  -41.321138381958, 27.4308943748474  ,  -59.1557377576828, -7.88524627685547  ,  -58.8048779964447, -35.7032508850098  },
		{   45.9918060302734, -4.65573692321777  ,  52.2213134765625, 7.73770523071289  ,  35.7601623535156, 27.4308943748474  ,  -41.321138381958, 27.4308943748474  ,  15.7786865234375, -13.0163917541504  ,  29.6147537231445, -18.196720123291  },
		{   -41.321138381958, 27.4308943748474  ,  -47.4344263076782, -13.0163917541504  ,  15.7786865234375, -13.0163917541504  }
	}
	
	self.buggyBody = world:createBody
	{
		type=b2.STATIC_BODY, 
		position = {x = application:getLogicalWidth()/2, y = application:getLogicalHeight()-35},
		fixedRotation = true,
		gravityScale = 0
	}	
	self.buggyBody.name = "buggy"

	for pg = 1, #polyGroup do
		local buggyPolyGroup = b2.PolygonShape.new()
		buggyPolyGroup:set(unpack(polyGroup[pg]))
		self.buggyBody:createFixture
		{
			shape = buggyPolyGroup, 
			density = 10, 
			restituition = 0.0, 
			friction = 0
		}
	end
	
	local bTexture = Bitmap.new(ingameGFX:getTextureRegion("buggy-no-ruote.png"))
		bTexture:setAnchorPoint(0.5, 0.5)
	
	self.ruotaAnteriore:setAnchorPoint(0.5, 0.5)
	self.ruotaPosteriore1:setAnchorPoint(0.5, 0.5)
	self.ruotaPosteriore2:setAnchorPoint(0.5, 0.5)
	self.ruotaAnteriore:setScale(.8)
	
	local buggyCar = Sprite.new()
	buggyCar:addChild(bTexture)
	buggyCar:addChild(self.ruotaAnteriore)
	buggyCar:addChild(self.ruotaPosteriore1)
	buggyCar:addChild(self.ruotaPosteriore2)
	buggyCar.body = self.buggyBody
	self.ruotaAnteriore:setPosition(35,22)
	self.ruotaPosteriore1:setPosition(-2,19)
	self.ruotaPosteriore2:setPosition(-33,19)
	stage:addChild(buggyCar)
	

	-- Manage Events ---
	self:addEventListener(Event.ADDED_TO_STAGE, self.onAddedToStage, self)
	self:addEventListener("stopevents", self.onRemovedFromStage, self)
	self:addEventListener(Event.REMOVED_FROM_STAGE, self.onRemovedFromStage, self)
end

-----------------------------------
-- Add event when added to stage --
-----------------------------------
function buggy:onAddedToStage()
	self:addEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
end
 
-------------------------------------------
-- Remove Event when removed from  stage --
-------------------------------------------
function buggy:onRemovedFromStage()
  self:removeEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
  self:removeEventListener("stopevents", self.onRemovedFromStage, self)
  self:removeEventListener(Event.REMOVED_FROM_STAGE, self.onRemovedFromStage, self)
end

-----------------------------------------------------------------------
-- [[ do logic of Buggy (move in opposite direction of Helicopter ]] --
-----------------------------------------------------------------------
function buggy:onEnterFrame()
	--local fx = 0
	local buggy_px, buggy_py = self.buggyBody:getPosition()
	
	local accelX = application:getAccelerometer()
		fx = accelX * 0.7
	
	if ((buggy_px+(fx*-1)-75) > 0) and  ((buggy_px+(fx*-1)+75) < application:getLogicalWidth()) then 
		self.rotazione = self.rotazione + (fx*3)*-1
		self.ruotaAnteriore:setRotation(self.rotazione)
		self.ruotaPosteriore1:setRotation(self.rotazione)
		self.ruotaPosteriore2:setRotation(self.rotazione)
		self.buggyBody:setPosition(buggy_px+(fx*-1), buggy_py)
	end
end

