--[[

	---------------------------------------------
	GidHelix
	a simple game made to test and learn 
	Gideros SDK Power and Lua coding.
	
	Coded By Gianluca D'Angelo Copyright (C) 2012
	contact: gregbug@gmail.com
	THIS PROGRAM IS FREEWARE
	
	L'Aquila, 15 Gennaio 2012
	---------------------------------------------
	MODULE: Main Loop In Game
	---------------------------------------------
	OK
--]]

-- [[ create one simple game level... ]] --
local gameOverTimer 		= Timer.new(2500, 1)
local inGameTimer			= Timer.new(1000, 0)
local explodeTimer			= Timer.new(1000, 0)
local aura					= nil
local auraRotation			= 0
local bombExplodeTime		= nil
local inPoints				= nil
local powerPoint			= nil

--------------------
-- Show Play Time --
--------------------
local function tmr_playTime()
	playTime = playTime + 1
	
	local hour    = math.floor(playTime / 3600)
	local minutes = math.floor((playTime - (hour * 3600))/60)
	local seconds = math.floor(playTime - (hour * 3600) -  (minutes * 60))
	
	if minutes < 10 then
		minutes = "0"..minutes
	end
	
	if seconds < 10 then
		seconds = "0"..seconds
	end

	txtTime:setText(minutes .. ":" .. seconds)
end

local function tmr_bomb()
	bombCountDown = bombCountDown - 1
	BombTimePTS = bombCountDown
end
function resetGameGlobalsToLevel_1()
	GameLevel				= 1
	MaxBirds				= 2
	BombsToSave 			= 2
	BombTime				= 25
	eliDamage				= 10
	PlayerScore				= 0
end

local UnloadInGameStage
-------------------------------------
-- Game over (delayed witha timer) --
-------------------------------------
local function onTimerGameOver(Event)
	inGameTimer:stop()
	--powerUpTimer:stop()
	UnloadInGameStage()
		
	------------------------------------------------------------
	-- Show End Menu and ask to the player if TryAgain or not --
	------------------------------------------------------------
	stage:addChild(CendMenu.new())
end



---------------------------------
-- Init game Level and objects --
---------------------------------
local function initLevel()
	world = nil
	collectgarbage()
	world = b2.World.new(0, 9.8, true)													-- define world...

	playTime				= 0															-- Player time
	BombsSaved 				= 0
	bombLeft				= 6														-- how many bombs
	eliPower				= 100														-- power (healt) of eli... 
	isGameOver 				= false
	eliBirdCollision		= false														-- collision beetwen eli and birds ?
	AttachBox				= false														-- need to attach a bomb? (was a box...:)
	bombAttached			= nil														-- pointer to the bomb to attach (was a box)
	transportJoint			= nil														-- physic joint to transport....
	
	-- Create screen bordes --
	createEdge(0, application:getContentHeight(), application:getContentWidth(), application:getContentHeight(), "bottom")
	createEdge(0,0, application:getContentWidth(), 0, "top")
	createEdge(0, 0, 0, application:getContentHeight(), "left")
	createEdge(application:getContentWidth(), 0, application:getContentWidth(), application:getContentHeight(), "right")
	createEdge(0, application:getContentHeight()-20, 30, application:getContentHeight(), "sx")
	createEdge(application:getContentWidth()-30, application:getContentHeight(), application:getContentWidth(), application:getContentHeight()-20, "dx")
	
	aura = Bitmap.new(ingameGFX:getTextureRegion("aurea.png"))
	aura:setAnchorPoint(0.5, 0.5)
	aura:setScale(1.2, 1.2)
	aura:setAlpha(0.45)
	
	stage:addChild(bgInGame)
	
	buggyCar = buggy.new()
	stage:addChild(buggyCar)
	
	for j = 1, 2 do
		for i = 1, 3 do
			local x = (application:getContentWidth()/2)-60 + i * 20
			local y = j * 20+application:getContentHeight()-105
			stage:addChild(bombs.new(x, y))
		end
	end 

	elisprite = eli.new()	
	stage:addChild(elisprite)

	bidonePlatform = platform.new()
	bidonePlatform:Show()
	
	-- [[ add evil birs... ]] --
	evilBirds = {}
	for i= 1, MaxBirds do
		evilBirds[i] = birds.new(true)
		stage:addChild(evilBirds[i])
	end
	
	-- Adding Text to Stage (score, time, etc.)
	local score = TextField.new(font, "Score")
	local healt = TextField.new(font, "HEALT")
	local timer = TextField.new(font, "time")
	local bombs = TextField.new(font, "Bombs left")
	local bombsS=TextField.new(font, "Bombs Saved")
	
	bombExplodeTime = TextField.new(font2, "25") 
	bombExplodeTime:setTextColor(0xFFFFFF)
	bombExplodeTime:setPosition(0,6)
	txtHealt = TextField.new(font2, eliPower)
	txtHealt:setPosition(66, 12)
	txtHealt:setTextColor(0xFFCC77)

	txtBombs = TextField.new(font2, bombLeft)
	txtBombs:setPosition(application:getContentWidth()-24, 12)
	txtBombs:setTextColor(0xFFCC77)

	txtBombSaved = TextField.new(font2, BombsSaved)
	txtBombSaved:setPosition(application:getContentWidth()-24, 26)
	txtBombSaved:setTextColor(0xFFCC77)

	txtScore = TextField.new(font2, PlayerScore)
	txtScore:setPosition(application:getContentWidth()/2, 26)
	txtScore:setTextColor(0xFFCC77)
	

	txtTime = TextField.new(font2, "00:00")
	txtTime:setPosition(application:getContentWidth()/2, 12)
	txtTime:setTextColor(0xFFCC77)


	txtFPS = TextField.new(font2, "0 FOS")
	txtFPS:setPosition(application:getContentWidth()/2-50, 100)
	txtFPS:setTextColor(0xFFFFFF)
	
	score:setPosition(application:getContentWidth()/2-50, 26)
	score:setTextColor(0xFFFFFF)
	
	healt:setPosition(20, 12)
	healt:setTextColor(0xFFFFFF)
	
	timer:setPosition(application:getContentWidth()/2-40, 12)
	timer:setTextColor(0xFFFFFF)
	
	bombs:setPosition(application:getContentWidth()-110, 12)
	bombs:setTextColor(0xFFFFFF)

	bombsS:setPosition(application:getContentWidth()-110, 26)
	bombsS:setTextColor(0xFFFFFF)

	inPoints = 	TextField.new(font3, "")
	inPoints:setTextColor(0xFFFFFF)
	
	powerPoint = 	TextField.new(font2, "")
	powerPoint:setTextColor(0xFFaacc)
	
	stage:addChild(score)
	stage:addChild(healt)
	stage:addChild(timer)
	stage:addChild(bombs)
	stage:addChild(bombsS)
	stage:addChild(txtHealt)
	stage:addChild(txtBombs)
	stage:addChild(txtScore)
	stage:addChild(txtTime)
	stage:addChild(txtBombSaved)

	stage:addChild(txtFPS)
	stage:addChild(inPoints)
	stage:addChild(powerPoint)
end

----------------------
-- InGame main Loop --
----------------------
local function onEnterFrameMainLoop(event)
	if not(isGameOver) then
		--print(biTouch)
		--------------------------
		-- Update Physics world --
		--------------------------
		-- do the low-pass filtering
		fdt = event.deltaTime * lowfilter + fdt * (1 - lowfilter)
		world:step(fdt, 9, 3)
	--	txtFPS:setText(fdt)
		--------------------------------------------------
		-- Draw all sprites aligned with physics engine...	
		--------------------------------------------------
		for i=1, stage:getNumChildren() do
			local sprite = stage:getChildAt(i)
			if sprite.body then
				sprite:setPosition(sprite.body:getPosition())
				sprite:setRotation(sprite.body:getAngle() * 180 / math.pi)
			end
		end
		----------------------------------------------
		-- check if we need to attach a bomb to eli... 
		----------------------------------------------
		if AttachBox then
			if (bombAttached) and (transportJoint == nil) then
				local cx, cy = bombAttached:getPosition()
				local Joint = b2.createRevoluteJointDef(gancioBody, bombAttached,  cx, cy)
				Joint.collideConnected = false
				Joint.enableLimit = true
				Joint.lowerAngle =  0
				transportJoint = world:createJoint(Joint)
				sndSfxChannel   = sfx_attachbomb:play()
				sndSfxChannel:setVolume(1)
				sndClockChannel   = sfx_clock:play(0, 1000)
				sndClockChannel:setVolume(1)
				explodeTimer:start()
				bombAttached.sprite:addChild(aura)
				bombExplodeTime:setPosition(-bombExplodeTime:getWidth()/2, bombExplodeTime:getHeight()/2)
				bombAttached.sprite:addChild(bombExplodeTime)
				AttachBox = false
			end
		end
		if (powerAttached) then
			stage:removeChild(powerAttached.sprite)
			powerAttached = nil
		end
	 -- explode bombs if time expired...
		if (transportJoint) then

			aura:setRotation(auraRotation)
			auraRotation = auraRotation +(500 * event.deltaTime)
			bombExplodeTime:setText(bombCountDown)
			bombExplodeTime:setPosition(-bombExplodeTime:getWidth()/2, bombExplodeTime:getHeight()/2)
			if bombCountDown == 0 then
				--explodeBomb(bombAttached)
				for i=1, stage:getNumChildren() do
					local spriteBomb = stage:getChildAt(i)
					if (spriteBomb.body == bombAttached) then
						local explodeBomb = explosion.new()
						explodeBomb:play(spriteBomb:getPosition())
						
						stage:removeChild(spriteBomb)
						world:destroyBody(bombAttached)

						local x,y = bidonePlatform:getXY()
						inPoints:setAlpha(1)
						inPoints:setScale(1,1)
						inPoints:setText("-200 PTS")
						inPoints:setPosition(x-inPoints:getWidth()/2, y)
						GTween.new(inPoints, 2, {alpha=0}, {ease = easing.linear})
						
						transportJoint 	= nil
						bombAttached 	= nil
						AttachBox 		= false
						bombLeft 		= bombLeft - 1
						PlayerScore 	= PlayerScore - 200
						if PlayerScore < 0 then
							PlayerScore = 0
						end
						if sndClockChannel then 
							sndClockChannel:stop()
						end
						txtBombs:setText(bombLeft)
						txtScore:setText(PlayerScore)
						bombCountDown			= BombTime
						spriteAura = nil
						break
					end
				end
				explodeTimer:stop()																		
				explodeTimer:reset()
			end
		else	
			if explodeTimer:isRunning() then
				explodeTimer:stop()																	-- start bomb timer!!!	
				explodeTimer:reset()
				bombCountDown			= BombTime
			end
		end
		if (explodeBombforCollision) then
			local explodeBomb = explosion.new()
			explodeBomb:play(explodeBombforCollision.sprite:getPosition())
		end
		--------------------------------
		-- Bombs is in the trash ... ---
		--------------------------------
		if (bombIsIn) then
			for i=1, stage:getNumChildren() do
			local sprite = stage:getChildAt(i)
				if sprite.body == bombIsIn then
					stage:removeChild(sprite)
					world:destroyBody(bombIsIn)
					bombIsIn 		= nil
					transportJoint 	= nil
					bombAttached 	= nil
					AttachBox 		= false
					spriteAura 		= nil
					bombLeft 		= bombLeft - 1
					BombsSaved		= BombsSaved + 1
					PlayerScore 	= PlayerScore + 100 + (BombTimePTS*15)
					
					if eliPower > 100 then 
						eliPower = 100 
					end	
					
					-- Show Score..
					local x,y = bidonePlatform:getXY()
					inPoints:setText("+"..(100 + (BombTimePTS*15)).." PTS")
					inPoints:setPosition(x-inPoints:getWidth()/2, y)
					inPoints:setAlpha(1)
					inPoints:setScale(1,1)
					GTween.new(inPoints, 2, {alpha=0}, {ease = easing.linear})
					-- Powerup
					if eliPower < 100 then
						if BombTimePTS+eliPower > 100 then
							BombTimePTS = 100-eliPower 
							eliPower = 100
						else
							eliPower = eliPower + BombTimePTS
						end
						powerPoint:setText("+"..BombTimePTS.."  POWERUP!")
						powerPoint:setPosition(x-powerPoint:getWidth()/2, y+30)
						powerPoint:setAlpha(1)
						powerPoint:setScale(1,1)
						GTween.new(powerPoint, 2.8, {alpha=0}, {ease = easing.linear})
						txtHealt:setText(eliPower)

					end
					
					if sndEliAlarm then
						sndEliAlarm:stop()
					end
					if sndClockChannel then 
						sndClockChannel:stop()
					end
					sndSfxChannel   = sfx_bIn:play()
					sndSfxChannel:setVolume(0.8)
					txtBombs:setText(bombLeft)
					txtScore:setText(PlayerScore)
					txtBombSaved:setText(BombsSaved)
					bidonePlatform:Show()
					break
				end
			end
		end
	end
	--print(bombCountDown)
	------------------------
	-- Check if game over --
	------------------------
	if (eliPower <= eliDeath) then
		gameOverTimer:start()
	end
	
	txtFPS:setText(1/fdt)
--	txtFPS:setText(stage:getNumChildren())
	
	if (bombLeft == 0) then
		if (BombsSaved < BombsToSave) then
			gameOverTimer:start()
		end
		if (BombsSaved >= BombsToSave) then
			UnloadInGameStage()
			unloadStage()
			GameLevel = GameLevel + 1
			stage:addChild(cShowLevel.new())
			isGameOver = false
		end
	end
	
end

------------------------------------------
-- Check user input (one ot two finger) --
------------------------------------------
local function onTouchesBegin(event)
	inTouch = true
	if eliPower > eliDeath then
		sndEliChannel:stop()
		sndEliChannel = sfx_eli2:play(0, 10000)
		sndEliChannel:setVolume(0.2)
	end
	if #event.allTouches == 2 then
		biTouch = true
		AttachBox = false
		-- if the player touch with 2 fingers and theis a transportJoint then release the bomb....
		if transportJoint then
			world:destroyJoint(transportJoint)
			transportJoint 	= nil
			if bombAttached then
				bombAttached.sprite:removeChild(aura)
				bombAttached.sprite:removeChild(bombExplodeTime)
			end
			bombAttached 	= nil
			transportJoint  = nil
			sndClockChannel:stop()
			sndSfxChannel	  = sfx_lasciabomba:play()
			sndSfxChannel:setVolume(0.8)
			explodeTimer:stop()																		
			explodeTimer:reset()
			bombCountDown			= BombTime
		end
	end
end

--------------------------
-- Check end user input --
--------------------------
local function onTouchesEnd(event)
	inTouch = false
	biTouch = false
	if eliPower > eliDeath then
		sndEliChannel:stop()
		sndEliChannel = sfx_eli1:play(0, 10000)
		sndEliChannel:setVolume(0.2)
	end
end


UnloadInGameStage =  function()
	isGameOver = true
	world:removeEventListener(Event.BEGIN_CONTACT, onBeginContact)
	world:removeEventListener(Event.END_CONTACT, onEndContact)

	--------------------------------------------------------------------
	-- remove events from sprites without removing sprites from stage --
	--------------------------------------------------------------------
	for i = 1, MaxBirds do 
		evilBirds[i]:dispatchEvent(evntSTOP)
	end
	buggyCar:dispatchEvent(evntSTOP)

	gameOverTimer:removeEventListener(Event.TIMER, onTimerGameOver)
	inGameTimer:removeEventListener(Event.TIMER, tmr_playTime)
	explodeTimer:removeEventListener(Event.TIMER, tmr_bomb)
--	powerUpTimer:removeEventListener(Event.TIMER, powerUp)

	stage:removeEventListener(Event.ENTER_FRAME, onEnterFrameMainLoop)
	stage:removeEventListener(Event.TOUCHES_BEGIN , onTouchesBegin)
	stage:removeEventListener(Event.TOUCHES_END, onTouchesEnd)
end

function RestartGame(RestartTheGame)
	if (RestartTheGame) then
		resetGameGlobalsToLevel_1()
	end
	initLevel()
--	sndEliChannel1 = sfx_eli1:play()
	--sndEliChannel1:setVolume(0.3)
	--[[ only for debug
		local debugDraw = b2.DebugDraw.new()
		world:setDebugDraw(debugDraw)
		stage:addChild(debugDraw)
	--]]
	if sndEliChannel then
		sndEliChannel:stop()
	end
	sndEliChannel = sfx_eli1:play(0, 10000)
	sndEliChannel:setVolume(0.2)
	----------------------
	-- Add BOX2D EVENTS --
	----------------------
	world:addEventListener(Event.BEGIN_CONTACT, onBeginContact)
	world:addEventListener(Event.END_CONTACT, onEndContact)

	stage:addEventListener(Event.ENTER_FRAME, onEnterFrameMainLoop)
	stage:addEventListener(Event.TOUCHES_BEGIN , onTouchesBegin)
	stage:addEventListener(Event.TOUCHES_END, onTouchesEnd)

	gameOverTimer:addEventListener(Event.TIMER, onTimerGameOver)
	inGameTimer:addEventListener(Event.TIMER, tmr_playTime)
	explodeTimer:addEventListener(Event.TIMER, tmr_bomb)
--	powerUpTimer:addEventListener(Event.TIMER, powerUp)
	inGameTimer:start()
--r	powerUpTimer:start()
end
