--[[

	---------------------------------------------
	GidHelix
	a simple game made to test and learn 
	Gideros SDK Power and Lua coding.
	
	Coded By Gianluca D'Angelo Copyright (C) 2012
	contact: gregbug@gmail.com
	THIS PROGRAM IS FREEWARE
	
	L'Aquila, 15 Gennaio 2012
	---------------------------------------------
	MODULE: Physics Collisions
	---------------------------------------------
	OK
--]]

-- [[ The next function will define a physical edge (thanks to mikehart) ]] --
function createEdge(x1, y1, x2, y2, name)
	-- Create the body
	local edge = world:createBody(
		{type=b2.STATIC_BODY, 
			fixedRotation = false,
			gravityScale = 0
		})
	-- Give the body a name
	edge.name = name
	-- Create a shape
	local eshape = b2.EdgeShape.new()
	-- Set one line for the edge
	eshape:set(x1, y1, x2, y2)

	-- Create the fixture
	edge:createFixture(
		{
			shape = eshape, 
			friction = 0,
			restitution = 0,
			density = 10  
		})
end

-- [[ detect collision from magnet hook and boxes [inGame] ]] --
function onBeginContact(event)
	-- you can get the fixtures and bodies in this contact like:
	local fixtureA = event.fixtureA
	local fixtureB = event.fixtureB
	local bodyA = fixtureA:getBody()
	local bodyB = fixtureB:getBody()

--[[
	if (bodyB.name == "bomb") then
		if (bodyA.name == "bottom") or (bodyA.name == "sx") or (bodyA.name == "dx") or (bodyA.name == "platform") or (bodyA.name == "buggy") then
			if math.abs(bodyB:getLinearVelocity()) >  3.2 then
				local explodeBomb = explosion.new()
				explodeBomb:play(bodyB:getPosition())
				explodeBombforCollision = bodyB
				 local timer = Timer.new(1, 1)
    --setting timer callback
    timer:addEventListener(Event.TIMER, function() 
        --remove bodies
        world:destroyBody(bodyB)
    end)
    --start timer
    timer:start()
			end
		else	
			explodeBombforCollision = nil
		end
	end
--]]

	if (bodyB.name == "gancio") then
		if (bodyA.name == "bomb") and not(biTouch) then
			if not (bombAttached) then
				bombAttached = fixtureA:getBody()
				AttachBox = true
			end
		end
	end

--[[
	if (bodyB.name == "power") and (bodyA.name == "gancio") then
			sndPowerChannel = sfx_powerup_gain:play(0,1)
			sndPowerChannel:setVolume(0.8)
			powerAttached = fixtureB:getBody()
	end
--]]

	-- Check collision from bird to Eli...
	if (bodyB.name == "bird") and (bodyA.name == "eli") then
		-- Play Contact eli animation (red one)
		eliAnimation:gotoAndPlay(23)
		eliBirdCollision = true
		sndSfxChannel   = sfx_evilbird:play()
		sndSfxChannel:setVolume(0.8)
	end
	
	if (bodyB.name == "inside") and (bodyA.name == "bomb") then
		bombIsIn = bodyA
	end
	
	if (bodyA.name == "bomb") or (bodyA.name == "eli") then
		if (bodyB.name == "platform") then
				sndSfxChannel   = sfx_sbattibomba:play()
				sndSfxChannel:setVolume(0.8)
		end
	end


	--[[
	--------------------------------------------
	-- Check if a bomb is falling to fast ... --
	-- if yes explode it!!!                   --
	--------------------------------------------
	if (bodyA.name == "bomb") then
		vx, vy = bodyA:getLinearVelocity()
		if vy > 2 then 
			explodeBomb = bodyA
		else
			explodeBomb = nil
		end
	end
	--]]
end

-- [[ detect end collision ]] --
function onEndContact(event)
-- you can get the fixtures and bodies in this contact like:
	local fixtureA = event.fixtureA
	local fixtureB = event.fixtureB
	local bodyA = fixtureA:getBody()
	local bodyB = fixtureB:getBody()

	if (bodyB.name == "bird") and (bodyA.name == "eli") then
		eliBirdCollision = false
		eli:playEliAnimation(true)
		eliPower = eliPower - eliDamage
		if (eliPower < 30) and not(alarmPlayng) and not(isGameOver) then
				sndEliAlarm   = sfx_alarm:play(0, 10000)
				sndEliAlarm:setVolume(0.8)
				alarmPlayng = true
		end
		txtHealt:setText(eliPower)
	end
end
