platform = gideros.class(Sprite)

function platform:init()
	self.xPos = math.random(50, 250)
	self.yPos = math.random(140, 300)
	self.oldXpos = self.xPos
	self.oldYpos = self.yPos

	self.platformGroup		= Sprite.new()
	self.platformSprite 	= Bitmap.new(ingameGFX:getTextureRegion("piattaforma.png"))
	self.bidoneSprite		= Bitmap.new(ingameGFX:getTextureRegion("bidone.png"))
	
	self.ledAnimFrames = {
		Bitmap.new(ingameGFX:getTextureRegion("piattaforma1.png")),
		Bitmap.new(ingameGFX:getTextureRegion("piattaforma2.png"))
	}
	
	self.ledAnimation = MovieClip.new{
		{1, 15, self.ledAnimFrames[1]},				-- Normal Speed animation frame 1
		{16, 31, self.ledAnimFrames[2]},				-- Normal Speed animation frame 2
	
	}
	
	self.ledAnimation:setGotoAction(31, 1)			-- Normal Speed Animation
	
		self.inside_body = world:createBody
		{
			type=b2.STATIC_BODY, 
			fixedRotation = false,
			gravityScale = 0
		}
		self.inside_body.name = "inside"
	
		self.platform_body = world:createBody
		{
			type=b2.STATIC_BODY, 
			fixedRotation = false,
			gravityScale = 0
		}
		self.platform_body.name = "platform"
		
		self.platform_shape = b2.PolygonShape.new()
		self.platform_shape:setAsBox(52,5,0,23,0)
--		self.platform_shape:setAsBox(55,55,22,63,0)
		self.platform_body:createFixture
		{
			isSensor = false,
			shape = self.platform_shape, 
			density = 1, 
			restituition = 02, 
			friction = 0.0 
		}
		
		self.bidone_shape = b2.PolygonShape.new()
		self.bidone_shape:setAsBox(19,10,1,6,0)
		self.inside_body:createFixture
		{
			isSensor = true,
			shape = self.bidone_shape, 
			density = 1, 
			restituition = 02, 
			friction = 0.0 
		}

		self.bidoneSX_shape = b2.PolygonShape.new()
		self.bidoneSX_shape:setAsBox(2,15,-20,1,0)
		self.platform_body:createFixture
		{
			isSensor = false,
			shape = self.bidoneSX_shape, 
			density = 1, 
			restituition = 02, 
			friction = 0.0 
		}

		self.bidoneDX_shape = b2.PolygonShape.new()
		self.bidoneDX_shape:setAsBox(2,15,23,1,0)
		self.platform_body:createFixture
		{
			isSensor = false,
			shape = self.bidoneDX_shape, 
			density = 10, 
			restituition = 02, 
			friction = 0.0 
		}


	self.platformSprite:setAnchorPoint(0.5, 0.5)
	self.bidoneSprite:setAnchorPoint(0.5, 0.5)
	self.body = self.platform_body
	
	self.platformSprite:setPosition(0,22)
	self.bidoneSprite:setPosition(0, 0)
	self.ledAnimation:setPosition(-63, 8)
	self.platformGroup:addChild(self.platformSprite)
	self.platformGroup:addChild(self.bidoneSprite)
	
	
	self.platformGroup:addChild(self.ledAnimation)
	self.ledAnimation:gotoAndPlay(1)
	
	stage:addChild(self.platformGroup)
end

function platform:getXY()
	return self.xPos, self.yPos
end
function platform:getX()
	return self.xPos
end
function platform:getY()
	return self.yPos
end
local function createShape(w, h, color, alpha)
	local shape = Shape.new()
	shape:setFillStyle(Shape.SOLID, color, alpha)
	shape:beginPath()
		shape:moveTo(-w, -h)
		shape:lineTo(w, -h)
		shape:lineTo(w, h)
		shape:lineTo(-w, h)
		shape:closePath()
	shape:endPath()
	return shape
end

collCheck_Box2B = function( source, target, newX, newY, sourceHeight)
	local rw = source:getWidth()/2.0 + target:getWidth()/2.0
	local rh = sourceHeight/2.0 + target:getHeight()/2.0
	if math.abs(source:getY() - newY) < rh then
		if math.abs(source:getX() - newX ) < rw then
			return true
		end
	end
	return false
end

function platform:replacePlatform()
	local ExitSpawn = false
	repeat	
		self.xPos = math.random(50, 250)
		self.yPos = math.random(140, 300)
		if collCheck_Box2B(elisprite, self.platformGroup, self.xPos, self.yPos, 75) then
			ExitSpawn = false
		else
			ExitSpawn = true
		end
	until ExitSpawn
	self.platform_body:setPosition(self.xPos, self.yPos)
	self.inside_body:setPosition(self.xPos, self.yPos)
end
function platform:Show()
	self:replacePlatform()	
	local movePlatformTween = GTween.new(self.platformGroup, 1.5,  {x = self.xPos, y = self.yPos}, {ease = easing.inOutCubic})
end

