cShowLevel = gideros.class(Sprite)

local delayTimer	= Timer.new(5000, 1)
local sprLevel		= Sprite.new()

function unloadStage()
	for j = stage:getNumChildren(), 1,-1 do
		stage:removeChildAt(j)
	end
	collectgarbage()
end

function cShowLevel:delay()
	delayTimer:stop()
	delayTimer:removeEventListener(Event.TIMER, self.delay)
	unloadStage()

	musicChannel:stop()
	musicChannel = mus_ingame:play(0, 10000)
	musicChannel:setVolume(0.2)
		if GameLevel == 1 then
		RestartGame(true)
		else
		-- Level 2, 3
		RestartGame(false)
	end


end

function cShowLevel:init()
	-- Stop all music and sfx
	if musicChannel then
		musicChannel:stop()
	end
	if sndEliAlarm then
		sndEliAlarm:stop()
	end
	if sndClockChannel then
		sndClockChannel:stop()
	end
	if sndSFXChannel then
		sndSFXChannel:stop()
	end
	if sndEliChannel then
		sndEliChannel:stop()
	end
	
	unloadStage()
	
	if sprLevel then
		for j = sprLevel:getNumChildren(), 1,-1 do
			sprLevel:removeChildAt(j)
		end
	end
	
	if (GameLevel >= 2) and (GameLevel <= 3) then
			MaxBirds				= 3
			BombsToSave 			= 2
			BombTime				= 20
			eliDamage				= 15
	end
	-- Level 4,5,6
	if (GameLevel >= 4) and (GameLevel <= 6) then
			MaxBirds				= 3
			BombsToSave 			= 3
			BombTime				= 18
			eliDamage				= 20
	end
	-- Level 7, 8, 9 , 10
	if (GameLevel >= 7) and (GameLevel <= 10) then
			MaxBirds				= 5
			BombsToSave 			= 4
			BombTime				= 15
			eliDamage				= 25
	end
		-- Level 10 to infinite
	if (GameLevel >10) then
			MaxBirds				= 6
			BombsToSave 			= 6
			BombTime				= 10
			eliDamage				= 30
	end

	local txtlevel = TextField.new(font3, "")
	txtlevel:setText("START LEVEL "..GameLevel)
	txtlevel:setPosition(application:getLogicalWidth()/2-txtlevel:getWidth()/2, 200)
	txtlevel:setTextColor(0xFFFFFF)
	sprLevel:addChild(txtlevel)
	
	local txtlevel =TextField.new(font2, "Evil Birds: "..MaxBirds)
	txtlevel:setPosition(application:getLogicalWidth()/2-txtlevel:getWidth()/2, 230)
	txtlevel:setTextColor(0xFFCC99)
	sprLevel:addChild(txtlevel)

	local txtlevel =TextField.new(font2, "Evil Birds Damage: "..eliDamage)
	txtlevel:setPosition(application:getLogicalWidth()/2-txtlevel:getWidth()/2, 245)
	txtlevel:setTextColor(0xFFCC99)
	sprLevel:addChild(txtlevel)

	local txtlevel =TextField.new(font2, "Bombs to save: "..BombsToSave)
	txtlevel:setPosition(application:getLogicalWidth()/2-txtlevel:getWidth()/2, 260)
	txtlevel:setTextColor(0xFFCC99)
	sprLevel:addChild(txtlevel)

	local txtlevel =TextField.new(font2, "Bombs timer: "..BombTime)
	txtlevel:setPosition(application:getLogicalWidth()/2-txtlevel:getWidth()/2, 275)
	txtlevel:setTextColor(0xFFCC99)
	sprLevel:addChild(txtlevel)

	
	stage:addChild(bgLevel)
	
	sprLevel:setPosition(application:getLogicalWidth()/2,0)
	GTween.new(sprLevel, 1.5, {x=0}, {ease = easing.outElastic})
	stage:addChild(sprLevel)

	musicChannel:stop()

	musicChannel = mus_level:play(0, 1)
	musicChannel:setVolume(0.2)

	self:addEventListener(Event.ADDED_TO_STAGE, self.onAddedToStage, self)
	self:addEventListener(Event.REMOVED_FROM_STAGE, self.onRemovedFromStage, self)
end

-----------------------------------------------------
-- Register event listner when added to the stage ---
-----------------------------------------------------
function cShowLevel:onAddedToStage()
  delayTimer:addEventListener(Event.TIMER, self.delay, self)
  delayTimer:start()
end
 
----------------------------------------------------
-- UnRegister events when removed from the stage ---
----------------------------------------------------
function cShowLevel:onRemovedFromStage()
	self:removeEventListener(Event.ADDED_TO_STAGE, self.onAddedToStage, self)
	self:removeEventListener(Event.REMOVED_FROM_STAGE, self.onRemovedFromStage, self)
	delayTimer:removeEventListener(Event.TIMER, self.delay)
end
